import { NgModule, ErrorHandler } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { IonicApp, IonicModule, IonicErrorHandler } from 'ionic-angular';
import { MyApp } from './app.component';
import { CanvasDraw } from '../components/canvas-draw/canvas-draw';
import { HttpClientModule} from '@angular/common/http';

import { HomePage } from '../pages/home/home';
//import { TabsPage } from '../pages/tabs/tabs';
import { Camera } from '@ionic-native/camera';
import { EditPage } from '../pages/edit/edit';

import { StatusBar } from '@ionic-native/status-bar';
import { SplashScreen } from '@ionic-native/splash-screen';
import { Network } from '@ionic-native/network';//BORIS

@NgModule({
  declarations: [
    MyApp,
    HomePage,
    EditPage,
    CanvasDraw
  ],
  imports: [
    BrowserModule,
    IonicModule.forRoot(MyApp),
    HttpClientModule
  ],
  bootstrap: [IonicApp],
  entryComponents: [
    MyApp,
    HomePage,
    EditPage,
    CanvasDraw
  ],
  providers: [
    StatusBar,
    SplashScreen,
    Camera,
    Network,
    {provide: ErrorHandler, useClass: IonicErrorHandler}
  ]
})
export class AppModule {}
