import { Component, ViewChild, Renderer } from '@angular/core';
import { Platform } from 'ionic-angular';
//import {createUrlResolverWithoutPackagePrefix} from "@angular/compiler";
import { NavController, NavParams } from 'ionic-angular';
import { Camera, CameraOptions } from '@ionic-native/camera';
//import {EditPage } from '../../pages/edit/edit';
import { HttpClient } from '@angular/common/http';
//import { File } from '@ionic-native/file';
import { Observable } from 'rxjs/Observable';
import { LoadingController } from 'ionic-angular';
//import {ResultatPage} from '../../pages/resultat/resultat';
import { HomePage } from '../../pages/home/home';
import { AlertController } from 'ionic-angular';
import { Network } from '@ionic-native/network';

//import {HttpHeaders} from '@angular/common/http';


//Colors
const COLOR_OTHER : string = 'rgb(0, 0, 255)';
const COLOR_WOUND : string = 'rgb(0, 255, 0)';


//Maximum size of image from camera/gallery.
//Images sent to the server will have at most this size.
const IMAGE_MAX_WIDTH : number = 1200;
const IMAGE_MAX_HEIGHT : number = 1200;

//Minimum and maximum scale (i.e., zoom) 
const MIN_SCALE : number = 0.5;
const MAX_SCALE : number = 5;


var load;
var alert;

//@serveur debian Nicho
//const urlServe : string = 'http://79.137.87.180/';
//@serveur Boris
//const urlServe : string = 'http://147.210.8.69/';
//@serveur Urgo
////const urlServe : string = 'https://wwwurgo.idshost.fr:8080/';
const urlServe : string = 'https://wwwurgo.idshost.fr/';
//WARNING: https and not http !!! (If there is a redirect POSt are transformed into GET and uploads fail)

// URL to upload original image to
const urlUploadImg : string = urlServe+'upload.php';

// URL to upload touch pts to and that will launch the segmentation on the server
const urlUploadPts : string = urlServe+'api.php';

// URL to upload corrected bitmap image to
const urlUploadBmp : string = urlServe+'uploadCorrectedBitmap.php';

// URL of directory where results are stored.
const urlResults : string = urlServe+'/results/';



@Component({
  selector: 'canvas-draw',
  templateUrl: 'canvas-draw.html'
})
export class CanvasDraw {
  image: string;
  options: string;
  optionsPicture: CameraOptions;
  imageName: string;
  imageNameReceived: boolean;
  submitPressed: boolean;

  @ViewChild('myCanvas') canvas: any;

  canvasElement: any;
  lastX: number;
  lastY: number;

  deviceWidth: number;
  deviceHeight: number;
  scaleDeviceToImage: number;

  pixelSize: number;
  resultArea: number;
  resultWidth: number;
  resultHeight: number;
  computedArea: number;
  computedWidth: number;
  computedHeight: number;

  colorOther: string = COLOR_OTHER; //'blue';
  colorWound: string = COLOR_WOUND; //'yellow';
  currentColor: string = this.colorWound;
  brushSize: number = 10;
  availableColours: any;  //used in html
  paintWithWoundColor: boolean;


  newPointList: string[];
  colorList: string [];
  brushSizeList: number[];
  pointsLists: any[];

  woundPtsList: string;
  otherPtsList: string;

  bitmapReceived: boolean;
  imgBitmap: any;

  isPinching: boolean;
  initialDistance: number;
  scale: number;
  tx: number;
  ty: number;
  currScale: number;
  currTx: number;
  currTy: number;

  constructor(public platform: Platform, public renderer: Renderer, public navCtrl: NavController, public navParams: NavParams, private camera: Camera, private network: Network,  public http: HttpClient, public loadingCtrl: LoadingController, private alertCtrl: AlertController) { 
    //Récupération des params
    this.optionsPicture = this.navParams.get('option');
    this.optionsPicture.targetWidth=IMAGE_MAX_WIDTH;
    this.optionsPicture.targetHeight=IMAGE_MAX_HEIGHT;

    this.deviceWidth = 0;
    this.deviceHeight = 0;
    this.scaleDeviceToImage = 0;

    this.pixelSize = 1;
    this.resultArea = 0;
    this.resultWidth = 0;
    this.resultHeight = 0;
    this.computedArea = 0;
    this.computedWidth = 0;
    this.computedHeight = 0;

    this.paintWithWoundColor = true;
    
    this.newPointList = [];
    this.colorList = [];
    this.brushSizeList = [];
    this.pointsLists = [];

    this.imgBitmap = new Image;
    this.bitmapReceived = false;

    this.isPinching = false;
    this.initialDistance = undefined;
    this.scale = 1;
    this.tx = 0;
    this.ty = 0;
    this.currScale = 1;
    this.currTx = 0;
    this.currTy = 0;

    this.takePicture();
    //console.log('Hello CanvasDraw Component');

    this.availableColours = [
      this.colorWound,
      this.colorOther
    ];

    this.http = http;


    load = this.loadingCtrl.create({
      content:'Veuillez patienter.....'
    });


  }

  ngAfterViewInit(){
    //Création du canvas
    this.canvasElement = this.canvas.nativeElement;
    this.renderer.setElementAttribute(this.canvasElement, 'width', 0 + '');
    this.renderer.setElementAttribute(this.canvasElement, 'height', 0 + '');

  }

  redirectionHomePage(){
    this.navCtrl.setRoot(HomePage);
  }

  //Prise ou import de la photo
  takePicture(){

    this.camera.getPicture(this.optionsPicture).then((imageData) => {

      //Récupération de l'image
      let base64Image = 'data:image/jpeg;base64,' + imageData;

      //Affichage de l'image
      let elem = document.getElementById("imageFile");
      elem.setAttribute("src", base64Image);
      this.image = base64Image;

      //B: Pourquoi on a un code synchrone et un code asynchrone (plus bas) ici ???
      //B: Est-on sûr que l'image est chargée quand on fait le uploadFile() ????

      // Upload de l'image sur le serveur
      this.uploadFile();

      //Redimensionnement du canvas en fonction de la taille de l'écran
      let img1;
      img1 = document.getElementById("imageFile");
      img1.onload = (event) => {  //BORIS: quand est-ce que se declanche le onload ??????
        this.deviceWidth = img1.clientWidth;
        this.deviceHeight = img1.clientHeight;
        this.renderer.setElementAttribute(this.canvasElement, 'width', this.deviceWidth + '');
        this.renderer.setElementAttribute(this.canvasElement, 'height', this.deviceHeight + '');

        //document.getElementById("demo").innerHTML= "connection="+(this.network.type !== 'none');//DEBUG

        document.getElementById("imageFile").style.webkitTransformOrigin = `0px 0px`;
        this.canvasElement.style.webkitTransformOrigin = `0px 0px`;

      }
    },
    (err)=>{
      console.log("error during getPicture(): " + err);
    })
  }

  uploadFile() {

    document.getElementById("demo").innerHTML= "upload "+urlUploadImg; //DEBUG



/*
  //BORIS: this was the original way to upload the image.
  //As I was not getting the images on Urgo server,
  // I added the "headers" part, but it did not change anything.
  //I then changed the code to use the same method than for bitmap upload (see new code).
  // The problem was just that the url was with http instead of https
  //(and thus on the server there is a redirect that transforms the POST into GET
  // and the uploaded image data is lost)


    let postData = new FormData();
    postData.append('file', this.image);
    //let data : Observable<any> = this.http.post(urlUploadImg, postData);

    const headers = new HttpHeaders();
    headers.append('Content-Type', 'multipart/form-data');
    headers.append('Accept', 'application/json');
    let data : Observable<any> = this.http.post(urlUploadImg, postData, {headers: headers})

    data.subscribe((result) => {
      const ok = result['result'];
      if (ok === true) {
        // SLICE -4 POUR SUPPRIMER L'EXTENSION DU FICHIER
        const resultat = result['image_name'].slice(0, -4);
        this.imageName = resultat;
        this.imageNameReceived = true;
        document.getElementById("demo").innerHTML= "upload done "+resultat; //DEBUG
        if (this.submitPressed) {
          this.submitPoints();
        }
      }
      else {
        if (this.submitPressed) {
          load.dismiss();
        }

        document.getElementById("demo").innerHTML= "ERROR on image upload";
        //TODO: show error message dialog and then return to homepage ??

      }

    },
    err => {
      if (err.status != 200) {
        document.getElementById("demo").innerHTML= "ERROR on image upload: err.status="+err.status;
      }
    }


    );
*/

    const dataURL = this.image.replace(/^data:image\/(png|jpg);base64,/, "");

    //BORIS:TODO: make a function !
    let request = new XMLHttpRequest();
    let fd = new FormData();
    fd.append('file', dataURL);
    request.open('POST', urlUploadImg, true);
    request.onload = e => {
      if (request.status == 200) {

        const text = request.responseText;
        const result = JSON.parse(text);
        const ok = result['result'];
        if (ok === true) {
          // SLICE -4 POUR SUPPRIMER L'EXTENSION DU FICHIER
          const resultat = result['image_name'].slice(0, -4);
          this.imageName = resultat;
          this.imageNameReceived = true;
          document.getElementById("demo").innerHTML= "upload done "+resultat; //DEBUG
          if (this.submitPressed) {
            this.submitPoints();
          }
        }
        else {
          if (this.submitPressed) {
            load.dismiss();
          }

          document.getElementById("demo").innerHTML= "ERROR on image upload";
          //TODO: show error message dialog and then return to homepage ??

        }

      }
      else {

        document.getElementById("demo").innerHTML= "error upload image : request.status="+request.status;//DEBUG
        console.log('upload image failed !!!');
      }
    }
    request.onerror = e => {
      console.log("error on image upload");
      const data = request.responseText;
      document.getElementById("demo").innerHTML= "error upload image="+data;//DEBUG
      this.showErrorMsg("Echec de transmission de l'image");
      if (this.submitPressed) {
        load.dismiss();
      }
    };
    //request.setRequestHeader('Content-Type', 'multipart/form-data');
    request.send(fd);

  
  }

  //BORIS:TODO: do we really have ints in the list ?

  formatPoint(xs, ys, scale) {
    const x = parseInt(xs, 10);
    const y = parseInt(ys, 10);
    const str = Math.round(x * scale) + ',' + Math.round(y*scale)
    return str;
  }

  //Scale points with ratio and format point lists in string
  formatPointsLists(arr, ratio) {
    this.woundPtsList="";
    this.otherPtsList="";

    for(let i = 0; i<arr.length; i++) {

      let split = arr[i][0].split(",");
      let str = this.formatPoint(split[0], split[1], ratio);
      let newArr = str;

      for(let j = 1; j <arr[i].length; j++) { //start from 1
        split = arr[i][j].split(",");
        str = this.formatPoint(split[0], split[1], ratio);
        newArr += ':' + str;
      }

      if (this.colorList[i] == this.colorWound) {
        if (this.woundPtsList.length > 0) 
          this.woundPtsList += '#';
        this.woundPtsList += newArr;
      }
      else { //other
        if (this.otherPtsList.length > 0) 
          this.otherPtsList += '#';
        this.otherPtsList += newArr;
      }
    }
    //let newArrBis = newArr.slice(9, -1);  /// SLICE START TO 9 BECAUSE OF AN 'UNDEFINED'
    //return newArrBis;
  }


/*
    alert = this.alertCtrl.create({
      title: 'Transmission impossible',
      subTitle: 'Vérifier votre connection internet',
      buttons: ['ok']
    });
*/

  //As image is sent as soon as it is available,
  // it would then be possible to send touch points BEFORE the imageName is received.
  // To prevent that, we have two booleans : imageNameReceived and submitPressed.
  // the real point submissions (via submitPts()) is launched when both conditions are true;

  //Send touch points to server
  submit() {

    load.present();
    if (this.imageNameReceived) {
      this.submitPoints();
    }
    else {
      this.submitPressed = true;
    }
  }

  submitPoints() {

    load.present();

    //compute ratio
    let imageBase = new Image();
    imageBase.src = document.getElementById("imageFile").getAttribute('src');
    //TODO:BORIS: are we sure it is synchronous ??????????
    this.scaleDeviceToImage = imageBase.width/this.deviceWidth;

    //format point lists
    this.formatPointsLists(this.pointsLists, this.scaleDeviceToImage);
    
    const myData = {woundPoints: this.woundPtsList, otherPoints: this.otherPtsList, imageName: this.imageName};

    let request = new XMLHttpRequest();

    request.open("POST", urlUploadPts, true);
    request.setRequestHeader("Content-Type", "text/plain");

    request.onload = e => {
      if (request.status==200) {
         const data = request.responseText;
         document.getElementById("demo").innerHTML= "upload pts Ok="+data;//DEBUG
         this.ptsAnswer(data);
      }
    }
    request.onerror = e => { 
      console.log("error on pts upload") 
      const data = request.responseText;
      document.getElementById("demo").innerHTML= "error upload pts="+data;//DEBUG
      this.showErrorMsg("Echec de transmission des points");
      load.dismiss();
    };

    request.send(JSON.stringify(myData));

    //hide submit button
    document.getElementById('valider').style.display = 'none';
    
  }

  showErrorMsg(msg) {
    alert = this.alertCtrl.create({
          title: 'Erreur',
          subTitle: msg,
          buttons: ['ok']
    });
    alert.present(); //BORIS:TODO: on devrait retourner sur Home quand validé???
  }


  getErrorMsg(data) {
    let msg='';
    switch (data) {
    case '0':
      msg='ok';
      break;
    case '1':
      msg='Mire non trouvée';
      break;
    case '2':  
      msg='Image invalide';
      break;
    case '3':
      msg='Mask invalide';
      break;
    case '4':
      msg='Points pour le fond invalides';
      break;
    case '5':
      msg='Points pour la plaie invalides';
      break;
    case '6':
      msg='Erreur écriture image';
      break;
    case '7':
      msg='Erreur écriture masque';
      break;
    case '8':
      msg='Erreur écriture informations';
      break;
    default:
      msg='Erreur '+data;
      break;
    }
    return msg;  
  }  

  ptsAnswer(data) {

    if (data == '0') {
      this.getResults();
    }
    else {
      const msg = this.getErrorMsg(data);
      load.dismiss();
      this.showErrorMsg(msg);
      //show submit button to be able to re-submit
      document.getElementById('valider').style.display = 'inline'; 
    }
 
  }

  getResults() {

    //first, get segmentation bitmap

    let resultImageFilename=urlResults+this.imageName+".png";

    this.imgBitmap.onload = e => {
      //then, get info text file 
      this.bitmapReceived = true;
      this.getResultInfo();
    }
    this.imgBitmap.onerror = ev => {
      this.showErrorMsg("Echec du chargement de l'image résultat");
    }
    this.imgBitmap.src = resultImageFilename;  

  }

  getResultInfo() {
    let resultInfoTextFilename=urlResults+this.imageName+".txt";

    let client = new XMLHttpRequest();
    client.open('GET', resultInfoTextFilename, true);
    client.setRequestHeader("Content-Type", "text/plain");
    client.onload = e => {
      if(client.status == 200) {
        //document.getElementById("demo").innerHTML= "txt="+client.responseText;//DEBUG
        this.parseInfo(client.responseText);
        this.updateBitmap();
      }
      else{
        this.showErrorMsg("Echec du chargement des informations résultat");
      }
    }
    client.onerror = e => {
      this.showErrorMsg("Echec requête informations résultat");
    }
    client.send();
  }

  parseInfo(infoText) {
    //document.getElementById("demo").innerHTML= "infos="+infoText;//DEBUG
    let res = infoText.split("\n");
    //document.getElementById("demo").innerHTML= "res[3]="+res[3]+"/"+res.length;//DEBUG
    for (let i = 0; i < res.length; i++) {
      let fields = res[i].split("=");
      if (fields.length == 2) {
        if (fields[0] == "PIXEL") {
          this.pixelSize = fields[1];
          //document.getElementById("demo").innerHTML= "pixelSize="+this.pixelSize;//DEBUG
        }
        else if (fields[0] == "AREA") {
          this.resultArea = fields[1];
        }
        else if (fields[0] == "WIDTH") {
          this.resultWidth = fields[1];
        }
        else if (fields[0] == "HEIGHT") {
          this.resultHeight = fields[1];
        }
      }
    }
  }

  drawBitmapOnCanvas() {
    //document.getElementById("demo").innerHTML= "updBmp canvas w="+this.canvasElement.width+" h="+this.canvasElement.height;//DEBUG
  
    let ctx = this.canvasElement.getContext('2d');

    //Draw image resized to canvas size 
    ctx.drawImage(this.imgBitmap, 0, 0, this.canvasElement.width, this.canvasElement.height);

    let imageData = ctx.getImageData(0, 0, this.canvasElement.width, this.canvasElement.height);
    let data = imageData.data;
    for (let i = 0; i < data.length; i += 4) {
      if (data[i + 2] == 255) { //wound
        data[i] = 0;
        data[i + 1] = 255;
        data[i + 2] = 0; //0;
        data[i + 3] = 128;
      } 
      else { //other 
        data[i] = 0;
        data[i + 1] =0;
        data[i + 2] = 255;
        data[i + 3] = 128; //transparent //255;
      }
    }
    ctx.putImageData(imageData, 0, 0);    
  }

  updateBitmap() {
    //Here, we consider that this.imgBitmap has been correctly loaded.

    this.drawBitmapOnCanvas();

    this.colorOther = 'rgba(0, 0, 255, 128)'; //transparent
    if (this.paintWithWoundColor == false)
      this.currentColor = this.colorOther; 
    this.availableColours[1] = this.colorOther;

    this.clearLists();

    document.getElementById('resultat').style.display = 'inline';
    load.dismiss();
  }


  updateGeometricInfo(data, width, height) {
    //Here, we consider that this.imgBitmap has been correctly loaded.

    let pointsMask : Point [] = [];

    //compute wound geometry infos (area and axis-aligned width & height)
    const inv_width : number = 1.0/width;
    // let xMin : number = width;
    // let xMax : number = 0;
    // let yMin : number = height;
    // let yMax : number = 0;
    let area : number = 0;

    for (let i = 0; i < data.length; i += 4) {
      if (data[i + 1] == 255) { //wound
         let y = Math.floor((i/4)*inv_width);
         let x = (i/4) - (y*width);

         // if (x < xMin) {
         //   xMin = x;
         // }
         // if (x > xMax) {
         //   xMax = x;
         // }
         // if (y < yMin) {
         //   yMin = y;
         // }
         // if (y > yMax) {
         //   yMax = y;
         // }

         pointsMask.push({x:x, y:y});
         area += 1;

         //document.getElementById("demo").innerHTML= "numPtsMask="+area;

      }

      //document.getElementById("demo").innerHTML= "i="+i+;
    }

    //document.getElementById("demo").innerHTML= "nPtsMsk="+pointsMask.length+" area="+area+"/"+(data.length/4);

    //Axis-aligned bounding box size
    //let bb_width = (xMax-xMin+1);
    //let bb_height = (yMax-yMin+1);

    //document.getElementById("demo").innerHTML= "nPtsMask="+pointsMask.length;
    let pointsHull : Point[] = new Array(pointsMask.length);

    let numPointsHull = chainHull_2D(pointsMask, pointsMask.length, pointsHull);

    //document.getElementById("demo").innerHTML= "numPointsHull="+numPointsHull;

    let rr = minAreaRect(pointsHull, numPointsHull);
    let bb_width : number = rr.width;
    let bb_height : number = rr.height;

    //document.getElementById("demo").innerHTML= "obb w="+bb_width+" h="+bb_height;//DEBUG


    //round to nearest 10^-1 value.
    this.computedArea = Math.floor(area*this.pixelSize*this.pixelSize*10 + 0.5)/10.0;
    this.computedWidth = Math.floor(bb_width*this.pixelSize*10 + 0.5)/10.0;
    this.computedHeight = Math.floor(bb_height*this.pixelSize*10 + 0.5)/10.0;
  }

  makeBlackWhiteColors(colorList, colorToWhite) {
    let colorList2 = [];
    for (let i=0; i<colorList.length; i++) {
      if (colorList[i]==colorToWhite) {
        colorList2.push('rgb(255, 255, 255)');
      }
      else {
        colorList2.push('rgb(0, 0, 0)');
      }
    }
    return colorList2;
  }


  updateBitmapInfo() {
    //Here, we consider that this.imgBitmap has been correctly loaded.

    //document.getElementById("demo").innerHTML= "update bitmap info";//DEBUG

    let img = document.createElement("canvas");
    img.width = this.imgBitmap.width;
    img.height = this.imgBitmap.height;
    let ctx = img.getContext("2d"); // add context to the copy for easy reference
    ctx.drawImage(this.imgBitmap, 0, 0);

    const width = this.imgBitmap.width;
    const height = this.imgBitmap.height;

    const colorListBW = this.makeBlackWhiteColors(this.colorList, this.colorWound);

    this.drawPointLists(ctx, colorListBW, this.pointsLists, this.brushSizeList, this.scaleDeviceToImage);
    const updated = (this.pointsLists.length > 0)
    //As soon as there are points, we consider that the bitmap has been updated
    //(As we do not know where touch points are drawn, the only other way would be
    // to compare area of wound before and after touch points draw...)

    let imageData = ctx.getImageData(0, 0, width, height);
    let data = imageData.data;

    this.updateGeometricInfo(data, width, height);
    
    //send corrected bitmap here, that we have the context ???
    if (updated == true) {

      let dataURL = img.toDataURL("image/png");
      dataURL = dataURL.replace(/^data:image\/(png|jpg);base64,/, "");

      //BORIS:TODO: make a function !
      let request = new XMLHttpRequest();
      let fd = new FormData();
      fd.append('bitmap', dataURL);
      fd.append('filename', this.imageName);
      request.open('POST', urlUploadBmp, true);
      request.onload = function () {
        if (request.status == 200) {
          //BORIS: we do not check the returned code (which should be 0 on success)
          // because the following code does not work !
          //const res = request.responseText;
          //const resOk = "0 "; //B: There is a space in responseText ! Why ????
          //if (res == resOk) {
          document.getElementById("demo").innerHTML= "upload bmp Ok";//DEBUG
          console.log('upload corrected bitmap ok');
        } 
        else {
          document.getElementById("demo").innerHTML= "error upload bmp !";//DEBUG
          console.log('upload corrected bitmap failed !!!');
        }
      };
      //request.setRequestHeader('Content-Type', 'multipart/form-data');
      request.send(fd);
    }
    //B:TODO: make sure it is received !!!!
  }


  showResults() {

/*
    load = this.loadingCtrl.create({
      content:'Veuillez patienter...'
    });
*/
    load.present();

    this.updateBitmapInfo();
    
    load.dismiss();

    alert = this.alertCtrl.create({
      title: 'Informations sur la plaie',
      //subTitle: msg,
      message: "<ul><li>surface: "+this.computedArea+" cm2<li>largeur: "+this.computedWidth+" cm<li>hauteur: "+this.computedHeight+" cm</ul>",//" <br>valeurs avant correction:<ul><li>surface: "+this.resultArea+" cm2<li>largeur: "+this.resultWidth+" cm<li>hauteur: "+this.resultHeight+" cm</ul><br>", //DEBUG 
      //message: "<ul><li>surface: "+this.computedArea+" cm2<li>largeur: "+this.computedWidth+" cm<li>hauteur: "+this.computedHeight+" cm</ul> <br>valeurs avant correction:<ul><li>surface: "+this.resultArea+" cm2<li>largeur: "+this.resultWidth+" cm<li>hauteur: "+this.resultHeight+" cm</ul><br>", //DEBUG 
      buttons: ['ok']
    });

    alert.present();
  }
  

/*
  redirectionResultat(){
    //BORIS: pour ouvrir la page Resultat
      this.navCtrl.setRoot(ResultatPage, {option: this.imageName});
    }
*/


  //Change brush color
  changeColour(colour, btn){

    if (btn == 1){
      this.paintWithWoundColor = true;
      document.getElementById("tattoo").style.border="2px solid black";
      document.getElementById("other").style.border="0px";
    }
    else{
      this.paintWithWoundColor = false;
      document.getElementById("tattoo").style.border="0px";
      document.getElementById("other").style.border="2px solid black";
    }
    this.currentColor = colour;
    
    //document.getElementById("demo").innerHTML= "button ";
    //document.getElementById("tattoo").style.background="black";
    //BORIS:TODO: on peut passer uniquement 'btn" ! 
  }

  //Change brush size
  changeSize(size){
    this.brushSize = size;
  }


  handleStart(ev){

    if (ev.touches.length === 2) {
      //document.getElementById("demo").innerHTML= "pinch";
      this.isPinching = true;
      this.handleStartPinch(ev);
    }
    else {
      //document.getElementById("demo").innerHTML= "touch simple";
      this.isPinching = false;
      this.handleStartSingleTouch(ev);
    }

  }

  handleMove(ev) {
    if (this.isPinching === true) {
      this.handleMovePinch(ev);
    }
    else {
      this.handleMoveSingleTouch(ev);
    }
  }

  handleStartSingleTouch(ev) {
    this.newPointList = [];
    this.lastX = ev.touches[0].pageX - this.canvasElement.offsetLeft;
    this.lastY = ev.touches[0].pageY - this.canvasElement.offsetTop;

    const invPt = this.inverseTransform(this.lastX, this.lastY);
    this.lastX = invPt.x;
    this.lastY = invPt.y;

    this.lastX = Math.round(this.lastX);
    this.lastY = Math.round(this.lastY);

    const pointPosition = this.lastX + "," + this.lastY;
    this.newPointList.push(pointPosition);

    //document.getElementById("demo").innerHTML= "touch "+this.lastX+","+this.lastY;
  }

  handleMoveSingleTouch(ev) {
    let ctx = this.canvasElement.getContext('2d');
    let currentX = ev.touches[0].pageX - this.canvasElement.offsetLeft;
    let currentY = ev.touches[0].pageY - this.canvasElement.offsetTop;

    const invPt = this.inverseTransform(currentX, currentY);
    currentX = invPt.x;
    currentY = invPt.y;

    currentX = Math.round(currentX);
    currentY = Math.round(currentY);

    const pointPosition = currentX + "," + currentY;
    this.newPointList.push(pointPosition);

    ctx.beginPath();
    ctx.lineJoin = "round";
    ctx.moveTo(this.lastX, this.lastY);
    ctx.lineTo(currentX, currentY);
    ctx.closePath();
    ctx.strokeStyle = this.currentColor;
    ctx.lineWidth = this.brushSize;
    ctx.stroke();

    this.lastX = currentX;
    this.lastY = currentY;

    //document.getElementById("demo").innerHTML= "touch "+this.lastX+", "+this.lastY+" off="+this.canvasElement.offsetLeft+", "+this.canvasElement.offsetTop;
  }

  handleEnd() {
    if (this.isPinching === true) {
      this.handleEndPinch();
      //DO NOT set isPinching to false here ! Otherwise, if we lift one finger, we will do a draw !
      //this.isPinching = false; //
    }
    else {
      this.handleEndSingleTouch();
    }
  }


  handleEndSingleTouch() {
    let color = this.colorWound;
    if (this.paintWithWoundColor == true) {
      color = this.colorWound;
    } else {
      color = this.colorOther;
    }
    this.colorList.push(color);
    this.pointsLists.push(this.newPointList);
    this.newPointList = [];
    this.brushSizeList.push(this.brushSize);
  }


  handleStartPinch(ev) {
    this.initialDistance = undefined;
  }

  handleMovePinch(ev) {
    if (!this.initialDistance) {
      this.initialDistance = this.getDistance(ev);
    }

    this.currScale = this.getScale(ev);

    const center = this.getCenter(ev);
    this.currTx = center.x - this.canvasElement.offsetLeft;
    this.currTy = center.y - this.canvasElement.offsetTop;

    let totalScale = this.currScale * this.scale;

    if (totalScale > MAX_SCALE) {
      this.currScale = MAX_SCALE / this.scale;
      totalScale = MAX_SCALE;      
    }
    else if (totalScale < MIN_SCALE) {
      this.currScale = MIN_SCALE / this.scale;
      totalScale = MIN_SCALE;      
    }

    let trans = this.getPostScale(this.currScale, this.currTx, this.currTy); 


    //document.getElementById("canvas");
    //this.applyScale(totalScale);
    this.applyTransformation(trans);

    //round just for print
    //this.currScale = Math.round(this.currScale * 100) / 100;
    //document.getElementById("demo").innerHTML= "pinch s="+this.scale+" cs="+this.currScale+" ts="+totalScale;

    //document.getElementById("demo").innerHTML= "center x="+center.x+" y="+center.y;
    //document.getElementById("demo").innerHTML= "offset left="+this.canvasElement.offsetLeft+" top="+this.canvasElement.offsetTop;
    //document.getElementById("demo").innerHTML= "pageY="+ev.touches[0].pageY+" clientY="+ev.touches[0].clientY;
    //document.getElementById("demo").innerHTML= "webkitTransformOrigin="+this.canvasElement.style.webkitTransformOrigin+" webkitTransform="+this.canvasElement.style.webkitTransform;
  }

  //Return scale centered on (px, py) added to current ransformation matrix 
  getPostScale(s, px, py) {
    //scale centered on (px, py) is translation of (-px;-py), scale, and translation of (px; py)
    //x' = (x-px)*scale + px = x*scale + (1-scale)*px;
    //So transformation={s,tx,ty}={s, (1-s)*px, (1-s)*py}

    //If we multiply two transformations : 
    // {s2, tx2, ty2}*{s1, tx1, ty1}={s2*s1, s2*tx1+tx2, s2*ty1+ty2}
    //So postScale(s, px, py)= {s*this.scale, s*this.tx+(1-s)*px, s*this.ty+(1-s)*py}

    return {s: s*this.scale, tx: s*this.tx+(1-s)*px, ty: s*this.ty+(1-s)*py}
  }

  getScale(ev) {
    return this.getDistance(ev) / this.initialDistance;
  }

  getDistance(ev) {
    const touch0 = ev.touches[0];
    const touch1 = ev.touches[1];

    return Math.sqrt(
      (touch0.pageX - touch1.pageX) * (touch0.pageX - touch1.pageX) +
      (touch0.pageY - touch1.pageY) * (touch0.pageY - touch1.pageY)
    );
  }

  getCenter(ev) {
    const touch0 = ev.touches[0];
    const touch1 = ev.touches[1];

    const x = (touch0.pageX + touch1.pageX) / 2;
    const y = (touch0.pageY + touch1.pageY) / 2;

    return {x:x, y:y};
  }

  handleEndPinch() {
    let trans = this.getPostScale(this.currScale, this.currTx, this.currTy);
    this.applyScale(trans);
    this.scale = trans.s;
    this.tx = trans.tx;
    this.ty = trans.ty;
    this.currScale = 1;
    this.currTx = 0;
    this.currTy = 0;


    //this.scale = this.scale * this.currScale;
    //round
    //this.scale = Math.round(this.scale * 100) / 100;

    //this.applyScale(this.scale);
    //this.currScale = 1;

    //document.getElementById("demo").innerHTML= "pinch s="+this.scale+" cs="+this.currScale+" ts="+this.scale+" end";
  }

  applyTransformation(trans) {
    //matrix of webkitTransform is stored this way ;
    // (1 3 5) 
    // (2 4 6)
    // (0 0 1)
    // où 5 et 6 sont la translation

    document.getElementById("imageFile").style.webkitTransform = `matrix(${trans.s}, 0, 0, ${trans.s}, ${trans.tx}, ${trans.ty})`;
    this.canvasElement.style.webkitTransform = `matrix(${trans.s}, 0, 0, ${trans.s}, ${trans.tx}, ${trans.ty})`;
  }

  applyScale(scale) {
    document.getElementById("imageFile").style.webkitTransform = `scale3d(${scale}, ${scale}, 1)`;
    this.canvasElement.style.webkitTransform = `scale3d(${scale}, ${scale}, 1)`;
  }

  inverseTransform(x, y) {
    const inv_scale = 1/this.scale;
    return {x: inv_scale*x + -this.tx*inv_scale, y: inv_scale*y + -this.ty*inv_scale}
  }

  //draw list of list of points on canvas
  drawPointLists(ctx, colorList, pointLists, brushSizeList, scale) {
    let split;
    //Draw list of list of points
    for(let j=0; j < pointLists.length; j++) {

      split = pointLists[j][0].split(",");
      let prevx = split[0]*scale;
      let prevy = split[1]*scale;
      
      //Draw list of points for wound 
      for (let i = 1; i < pointLists[j].length; i++) { //start from 1
        split = pointLists[j][i].split(",");
        let x = split[0]*scale;
        let y = split[1]*scale;

        ctx.beginPath();
        ctx.lineJoin = "round";
        ctx.moveTo(prevx, prevy);
        ctx.lineTo(x, y);
        ctx.closePath();
        ctx.strokeStyle = colorList[j];
        ctx.lineWidth = brushSizeList[j]*scale;
        ctx.stroke();
        
        prevx = x;
        prevy = y;
      }
      //This is probably not the fastest way to draw these segments.
      //Indeed, we draw a segment of length N as N-1 small segments.
      //However, it ensures that we draw exactly the same way than when 
      //we draw touches (with round shaped segments). This way there is 
      //nothing that changes when we do undo and redraw. 
      
    }
  }

  clearLastPoints() {
  
    if (this.colorList.length > 0) {

      let ctx = this.canvasElement.getContext('2d');
      ctx.clearRect(0, 0, this.canvasElement.width, this.canvasElement.height);

      this.pointsLists.pop();
      this.colorList.pop();
      this.brushSizeList.pop();

      if (this.bitmapReceived)
        this.drawBitmapOnCanvas();

      //draw touch points lists with scale=1
      this.drawPointLists(ctx, this.colorList, this.pointsLists, this.brushSizeList, 1);
    }
  }

  clearAllPoints(){
    this.clearLists();

    if (this.bitmapReceived) {
      this.drawBitmapOnCanvas();
    }
    else {
      let ctx = this.canvasElement.getContext('2d');
      ctx.clearRect(0, 0, this.canvasElement.width, this.canvasElement.height);
    }
  }

  clearLists() {
    this.newPointList = [];
    this.pointsLists = [];
    this.colorList = [];
    this.brushSizeList = [];
  }


}



class Point {
  x: number;
  y: number;

  constructor(x: number, y: number) { this.x = x; this.y = y }

}



// Copyright 2001, softSurfer (www.softsurfer.com)
// This code may be freely used and modified for any purpose
// providing that this copyright notice is included with it.
// SoftSurfer makes no warranty for this code, and cannot be held
// liable for any real or imagined damage resulting from its use.
// Users of this code must verify correctness for their application.
// http://softsurfer.com/Archive/algorithm_0203/algorithm_0203.htm
// Assume that a class is already given for the object:
//    Point with coordinates {float x, y;}
//===================================================================

// isLeft(): tests if a point is Left|On|Right of an infinite line.
//    Input:  three points P0, P1, and P2
//    Return: >0 for P2 left of the line through P0 and P1
//            =0 for P2 on the line
//            <0 for P2 right of the line

// function sortPointX(a, b) {
//     return a.x - b.x;
// }
// function sortPointY(a, b) {
//     return a.y - b.y;
// }

function isLeft(P0, P1, P2) {    
    return (P1.x - P0.x) * (P2.y - P0.y) - (P2.x - P0.x) * (P1.y - P0.y);
}
//===================================================================

// chainHull_2D(): A.M. Andrew's monotone chain 2D convex hull algorithm
// http://softsurfer.com/Archive/algorithm_0109/algorithm_0109.htm
// 
//     Input:  P[] = an array of 2D points 
//                   presorted by increasing x- and y-coordinates
//             n = the number of points in P[]
//     Output: H[] = an array of the convex hull vertices (max is n)
//     Return: the number of points in H[]


function chainHull_2D(P, n, H) {
    // the output array H[] will be used as the stack
    var bot = 0,
    top = (-1); // indices for bottom and top of the stack
    var i; // array scan index
    // Get the indices of points with min x-coord and min|max y-coord
    var minmin = 0,
        minmax;
        
    var xmin = P[0].x;
    for (i = 1; i < n; i++) {
        if (P[i].x != xmin) {
            break;
        }
    }
    
    minmax = i - 1;
    if (minmax == n - 1) { // degenerate case: all x-coords == xmin 
        H[++top] = P[minmin];
        if (P[minmax].y != P[minmin].y) // a nontrivial segment
            H[++top] = P[minmax];
        H[++top] = P[minmin]; // add polygon endpoint
        return top + 1;
    }

    // Get the indices of points with max x-coord and min|max y-coord
    var maxmin, maxmax = n - 1;
    var xmax = P[n - 1].x;
    for (i = n - 2; i >= 0; i--) {
        if (P[i].x != xmax) {
            break; 
        }
    }
    maxmin = i + 1;

    // Compute the lower hull on the stack H
    H[++top] = P[minmin]; // push minmin point onto stack
    i = minmax;
    while (++i <= maxmin) {
        // the lower line joins P[minmin] with P[maxmin]
        if (isLeft(P[minmin], P[maxmin], P[i]) >= 0 && i < maxmin) {
            continue; // ignore P[i] above or on the lower line
        }
        
        while (top > 0) { // there are at least 2 points on the stack
            // test if P[i] is left of the line at the stack top
            if (isLeft(H[top - 1], H[top], P[i]) > 0) {
                break; // P[i] is a new hull vertex
            }
            else {
                top--; // pop top point off stack
            }
        }
        
        H[++top] = P[i]; // push P[i] onto stack
    }

    // Next, compute the upper hull on the stack H above the bottom hull
    if (maxmax != maxmin) { // if distinct xmax points
        H[++top] = P[maxmax]; // push maxmax point onto stack
    }
    
    bot = top; // the bottom point of the upper hull stack
    i = maxmin;
    while (--i >= minmax) {
        // the upper line joins P[maxmax] with P[minmax]
        if (isLeft(P[maxmax], P[minmax], P[i]) >= 0 && i > minmax) {
            continue; // ignore P[i] below or on the upper line
        }
        
        while (top > bot) { // at least 2 points on the upper stack
            // test if P[i] is left of the line at the stack top
            if (isLeft(H[top - 1], H[top], P[i]) > 0) { 
                break;  // P[i] is a new hull vertex
            }
            else {
                top--; // pop top point off stack
            }
        }
        
        if (P[i].x == H[0].x && P[i].y == H[0].y) {
            return top + 1; // special case (mgomes)
        }
        
        H[++top] = P[i]; // push P[i] onto stack
    }
    
    if (minmax != minmin) {
        H[++top] = P[minmin]; // push joining endpoint onto stack
    }
    
    return top + 1;
}


function minAreaRect(points, n) {
  let width : number = 0;
  let height : number = 0;

  //inspired from rotatingCalipers() from OpenCV 3.4.1

  let minarea : number = 888000000;
  
  let buf : number [] = new Array(7);
  let inv_vect_length : number [] = new Array(n);
  let vect : Point[] = new Array(n);

  let left : number = 0;
  let bottom : number = 0;
  let right : number = 0;
  let top : number = 0;

  let seq : number[] = [-1, -1, -1, -1];

  /* rotating calipers sides will always have coordinates
     (a,b) (-b,a) (-a,-b) (b, -a)
  */
  /* this is a first base bector (a,b) initialized by (1,0) */
  let orientation : number = 0;
  let base_a : number = 0;
  let base_b : number = 0;

  let left_x, right_x, top_y, bottom_y;
  let pt0 : Point = points[0];
  
  left_x = right_x = pt0.x;
  top_y = bottom_y = pt0.y;
  
  for(let i = 0; i < n; i++ ) {
    let dx : number;
    let dy : number;
    
    //TODO: est-ce que cette syntaxe est correcte ???

    if( pt0.x < left_x )
      left_x = pt0.x, left = i;
    
    if( pt0.x > right_x )
      right_x = pt0.x, right = i;
    
    if( pt0.y > top_y )
      top_y = pt0.y, top = i;
    
    if( pt0.y < bottom_y )
      bottom_y = pt0.y, bottom = i;
    
    let pt : Point = points[(i+1) & (i+1 < n ? -1 : 0)];
    
    dx = pt.x - pt0.x;
    dy = pt.y - pt0.y;
    
    vect[i] = { x: dx, y: dy };
    inv_vect_length[i] = (1./Math.sqrt(dx*dx + dy*dy));
    
    pt0 = pt;
  }

  // find convex hull orientation
  {
    let ax : number = vect[n-1].x;
    let ay : number = vect[n-1].y;
    
    for(let i = 0; i < n; i++ ) {
      let bx : number = vect[i].x;
      let by : number = vect[i].y;
      
      let convexity : number = ax * by - ay * bx;
      
      if( convexity != 0 ) {
         orientation = (convexity > 0) ? 1. : (-1.);
         break;
      }
      ax = bx;
      ay = by;
    }
    //assert( orientation != 0 );
  }
  base_a = orientation;

  /*****************************************************************************************/
  /*                         init calipers position                                        */
  seq[0] = bottom;
  seq[1] = right;
  seq[2] = top;
  seq[3] = left;
  /*****************************************************************************************/
  /*                         Main loop - evaluate angles and rotate calipers               */
  
  /* all of edges will be checked while rotating calipers by 90 degrees */
  for(let k = 0; k < n; k++ ) {
    /* sinus of minimal angle */
    /*float sinus;*/
    
    /* compute cosine of angle between calipers side and polygon edge */
    /* dp - dot product */
    let dp : number[] = [
      +base_a * vect[seq[0]].x + base_b * vect[seq[0]].y,
      -base_b * vect[seq[1]].x + base_a * vect[seq[1]].y,
      -base_a * vect[seq[2]].x - base_b * vect[seq[2]].y,
      +base_b * vect[seq[3]].x - base_a * vect[seq[3]].y,
    ];

    let maxcos : number = dp[0] * inv_vect_length[seq[0]];

    /* number of calipers edges, that has minimal angle with edge */
    let main_element : number = 0;
    
    /* choose minimal angle */
    for (let i = 1; i < 4; i++ ) { //start from 1
      let cosalpha : number = dp[i] * inv_vect_length[seq[i]];
      if (cosalpha > maxcos) {
         main_element = i;
         maxcos = cosalpha;
      }
    }
    
    /*rotate calipers*/
    {
      //get next base
      let pindex : number = seq[main_element];
      let lead_x : number = vect[pindex].x*inv_vect_length[pindex];
      let lead_y : number = vect[pindex].y*inv_vect_length[pindex];
      switch( main_element ) {
      case 0:
        base_a = lead_x;
        base_b = lead_y;
        break;
      case 1:
        base_a = lead_y;
        base_b = -lead_x;
        break;
      case 2:
        base_a = -lead_x;
        base_b = -lead_y;
        break;
      case 3:
        base_a = -lead_y;
        base_b = lead_x;
        break;
      default:
        //CV_Error(CV_StsError, "main_element should be 0, 1, 2 or 3");
        break;
      }
    }
    /* change base point of main edge */
    seq[main_element] += 1;
    seq[main_element] = (seq[main_element] == n) ? 0 : seq[main_element];
    
    /* find area of rectangle */
    {
      
      /* find vector left-right */
      let dx : number = points[seq[1]].x - points[seq[3]].x;
      let dy : number = points[seq[1]].y - points[seq[3]].y;
      
      /* dotproduct */
      let width : number = dx * base_a + dy * base_b;
      
      /* find vector left-right */
      dx = points[seq[2]].x - points[seq[0]].x;
      dy = points[seq[2]].y - points[seq[0]].y;
    
      /* dotproduct */
      let height : number = -dx * base_b + dy * base_a;
      
      let area : number = width * height;
      if( area <= minarea ) {
        
        minarea = area;
        /* leftist point */
        buf[0] = seq[3];
        buf[1] = base_a;
        buf[2] = width;
        buf[3] = base_b;
        buf[4] = height;
        /* bottom point */
        buf[5] = seq[0];
        buf[6] = area;
      }
    }
    
  }   /* for */
      
  let A1 : number = buf[1];
  let B1 : number = buf[3];
  
  let A2 : number = -buf[3];
  let B2 : number = buf[1];
  
  //let C1 : number = A1 * points[buf[0]].x + points[buf[0]].y * B1;
  //let C2 : number = A2 * points[buf[5]].x + points[buf[5]].y * B2;
  
  //let idet : number = 1.0 / (A1 * B2 - A2 * B1);
    
  //let px : number = (C1 * B2 - C2 * B1) * idet;
  //let py : number = (A1 * C2 - A2 * C1) * idet;
    
  //let out0 : number = px;
  //let out1 : number = py;
    
  let out2 : number = A1 * buf[2];
  let out3 : number = B1 * buf[2];
    
  let out4 : number = A2 * buf[4];
  let out5 : number = B2 * buf[4];

  //let center_x : number = out0.x + (out2 + out4)*0.5f;
  //let center_y : number = out0.y + (out3 + out5)*0.5f;
  width = Math.sqrt(out2*out2 + out3*out3);
  height = Math.sqrt(out4*out4 + out5*out5);
  //let angle : number = Math.atan2(out3, out2); //*M_PI/180;
  //let b : number = Math.cos(angle)*0.5;
  //let a : number = Math.sin(angle)*0.5;

  width = Math.ceil(width);
  height = Math.ceil(height);
  if (width < height) { //To always have the same order : width >= height
    //swap
    let tmp = width;
    width = height;
    height = tmp;
  }

  return {width: width, height: height};
}