import { Component } from '@angular/core';
import { NavController } from 'ionic-angular';
import { Camera, CameraOptions } from '@ionic-native/camera';
import { CanvasDraw } from '../../components/canvas-draw/canvas-draw';
import { Network } from '@ionic-native/network';
import { AlertController } from 'ionic-angular';

var alert;
var disconnectSubscription;
var connectSubscription;

@Component({
  selector: 'page-home',
  templateUrl: 'home.html'
})

export class HomePage {

	image: string;
  optionsTakePicture: CameraOptions = { destinationType: this.camera.DestinationType.DATA_URL,
                      encodingType: this.camera.EncodingType.JPEG,
                      mediaType: this.camera.MediaType.PICTURE,
                      quality: 100,
                      allowEdit: true,
                      sourceType: this.camera.PictureSourceType.CAMERA
  }

  optionsImportPicture: CameraOptions = { destinationType: this.camera.DestinationType.DATA_URL,
                      encodingType: this.camera.EncodingType.JPEG,
                      mediaType: this.camera.MediaType.PICTURE,
                      quality: 100,
                      allowEdit: true,
                      sourceType: this.camera.PictureSourceType.PHOTOLIBRARY
  }


  constructor(private camera: Camera, public navCtrl: NavController, private network: Network, private alertCtrl: AlertController) {

    disconnectSubscription = this.network.onDisconnect().subscribe(() => {
      console.log('network was disconnected :-(');
      document.getElementById('camera').style.display = 'none'; 
      document.getElementById('gallery').style.display = 'none'; 
      alert = this.alertCtrl.create({
        title: 'Transmission impossible',
        subTitle: 'Vérifier votre connection internet',
        buttons: ['ok']
      });
      alert.present();
    });


    connectSubscription = this.network.onConnect().subscribe(() => {
      console.log('network connected!');
      document.getElementById('camera').style.display = 'inline'; 
      document.getElementById('gallery').style.display = 'inline'; 
    });

  }


  //Fonctions de redirection en fonction du choix de l'utilisateur
  // Prendre ou Import photo

  redirectionTakePic(){
    this.navCtrl.setRoot(CanvasDraw, {option: this.optionsTakePicture});
  }

  redirectionImportPic(){
    this.navCtrl.setRoot(CanvasDraw, {option: this.optionsImportPicture});
  }

}
